> ## Documentation Index
> Fetch the complete documentation index at: https://docs.vantage.sh/llms.txt
> Use this file to discover all available pages before exploring further.

# Vantage API Reference

> Complete reference of all Vantage API endpoints. This page is auto-generated from the OpenAPI specification.

<Note>
  This page is auto-generated from the [OpenAPI specification](https://api.vantage.sh/v2/oas_v3.json).
  For interactive testing and detailed schemas, visit the individual endpoint pages linked below.
</Note>

## AccessGrants

### GET /access\_grants

**Get all access grants**

Return all Access Grants that the current API token has access to.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accessgrants/get-all-access-grants](https://docs.vantage.sh/api/accessgrants/get-all-access-grants)
</Card>

***

### POST /access\_grants

**Create access grant**

Create an Access Grant.

#### Request Body

```json theme={null}
{
  "resource_token": string // required // The token of the resource for which you are granting access,
  "team_token": string // required // The token of the Team you want to grant access to,
  "access": string // The access level you want to grant. Defaults to 'allowed'. Allowed values: `denied`, `allowed`
}
```

#### Responses

**201**: Created

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**406**: NotAcceptable

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accessgrants/create-access-grant](https://docs.vantage.sh/api/accessgrants/create-access-grant)
</Card>

***

### DELETE /access\_grants/{access_grant_token}

**Delete access grant**

Delete an Access Grant.

#### Path Parameters

* **access\_grant\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accessgrants/delete-access-grant](https://docs.vantage.sh/api/accessgrants/delete-access-grant)
</Card>

***

### GET /access\_grants/{access_grant_token}

**Get access grant by token**

Return a specific Access Grant.

#### Path Parameters

* **access\_grant\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accessgrants/get-access-grant-by-token](https://docs.vantage.sh/api/accessgrants/get-access-grant-by-token)
</Card>

***

### PUT /access\_grants/{access_grant_token}

**Update access grant**

Update an AccessGrant.

#### Path Parameters

* **access\_grant\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "access": string // required // Allowed or denied access to resource. Allowed values: `denied`, `allowed`
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accessgrants/update-access-grant](https://docs.vantage.sh/api/accessgrants/update-access-grant)
</Card>

***

## AccessPolicies

### GET /access\_policies

**Get all access policies**

Return all Access Policies for the current account.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

#### Responses

**200**: OK

**403**: Forbidden

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accesspolicies/get-all-access-policies](https://docs.vantage.sh/api/accesspolicies/get-all-access-policies)
</Card>

***

### POST /access\_policies

**Create access policy**

Create an Access Policy. Requires a personal API token belonging to a user with the Owner role and the write scope.

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the AccessPolicy,
  "policy": { // required // The AccessPolicy definition as a v1 document with vantage.* VQL
    "api_version": string // required // The AccessPolicy document version. Allowed values: `v1`,
    "policy": { // required // The AccessPolicy rules for this version
      "filter": string // required // Vantage Query Language (VQL) that controls which costs this AccessPolicy allows
    }
  },
  "description": string // The description of the AccessPolicy,
  "team_tokens": [string] // The tokens for Teams this AccessPolicy is assigned to
}
```

#### Responses

**201**: Created

**400**: BadRequest

**403**: Forbidden

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accesspolicies/create-access-policy](https://docs.vantage.sh/api/accesspolicies/create-access-policy)
</Card>

***

### DELETE /access\_policies/{access_policy_token}

**Delete access policy**

Delete an Access Policy. Requires a personal API token belonging to a user with the Owner role and the write scope.

#### Path Parameters

* **access\_policy\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**403**: Forbidden

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accesspolicies/delete-access-policy](https://docs.vantage.sh/api/accesspolicies/delete-access-policy)
</Card>

***

### PUT /access\_policies/{access_policy_token}

**Update access policy**

Update an Access Policy. Requires a personal API token belonging to a user with the Owner role and the write scope.

#### Path Parameters

* **access\_policy\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the AccessPolicy,
  "policy": { // The AccessPolicy definition as a v1 document with vantage.* VQL
    "api_version": string // required // The AccessPolicy document version. Allowed values: `v1`,
    "policy": { // required // The AccessPolicy rules for this version
      "filter": string // required // Vantage Query Language (VQL) that controls which costs this AccessPolicy allows
    }
  },
  "description": string // The description of the AccessPolicy,
  "team_tokens": [string] // The tokens for Teams this AccessPolicy is assigned to
}
```

#### Responses

**200**: OK

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/accesspolicies/update-access-policy](https://docs.vantage.sh/api/accesspolicies/update-access-policy)
</Card>

***

## Annotations

### GET /annotations

**Get all annotations**

Return all Annotations.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The number of results to return. The maximum is 5000.

* **report\_token** (string) - Optional: Filter by Report token.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/annotations/get-all-annotations](https://docs.vantage.sh/api/annotations/get-all-annotations)
</Card>

***

### POST /annotations

**Create an annotation**

Create an Annotation.

#### Request Body

```json theme={null}
{
  "report_tokens": [string] // required // The tokens of the Reports to annotate,
  "title": string // The title of the Annotation. Defaults to a title generated from the first Report and date,
  "date": string // required // The date of the Annotation. ISO 8601 formatted,
  "message": string // required // The message of the Annotation
}
```

#### Responses

**201**: Annotation created successfully.

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/annotations/create-an-annotation](https://docs.vantage.sh/api/annotations/create-an-annotation)
</Card>

***

### DELETE /annotations/{annotation_token}

**Delete an annotation**

Delete an Annotation.

#### Path Parameters

* **annotation\_token** (path) (string) - **Required**: The token of the Annotation.

#### Responses

**204**: Annotation deleted successfully.

**403**: Forbidden

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/annotations/delete-an-annotation](https://docs.vantage.sh/api/annotations/delete-an-annotation)
</Card>

***

### PUT /annotations/{annotation_token}

**Update an annotation**

Update an Annotation.

#### Path Parameters

* **annotation\_token** (path) (string) - **Required**: The token of the Annotation.

#### Request Body

```json theme={null}
{
  "title": string // The title of the Annotation,
  "date": string // The date of the Annotation. ISO 8601 formatted,
  "message": string // The message of the Annotation,
  "report_tokens": [string] // The tokens of the Reports to associate with the Annotation
}
```

#### Responses

**200**: Annotation updated successfully.

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/annotations/update-an-annotation](https://docs.vantage.sh/api/annotations/update-an-annotation)
</Card>

***

## AnomalyAlerts

### GET /anomaly\_alerts

**Get all anomaly alerts**

Return all Anomaly Alerts that the current API token has access to.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

* **start\_date** (string (date-time)) - Optional: The start date of the anomalies to return. ISO 8601 formatted.

* **end\_date** (string (date-time)) - Optional: The end date of the anomalies to return. ISO 8601 formatted.

* **provider** (string) - Optional: The provider of the anomalies to return.

* **service** (string) - Optional: The service of the anomalies to return.

* **cost\_category** (string) - Optional: The cost category of the anomalies to return.

* **cost\_report\_token** (string) - Optional: The cost report token of the anomalies to return.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalyalerts/get-all-anomaly-alerts](https://docs.vantage.sh/api/anomalyalerts/get-all-anomaly-alerts)
</Card>

***

### GET /anomaly\_alerts/{anomaly_alert_token}

**Get anomaly alert by token**

Return an AnomalyAlert that the current API token has access to.

#### Path Parameters

* **anomaly\_alert\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalyalerts/get-anomaly-alert-by-token](https://docs.vantage.sh/api/anomalyalerts/get-anomaly-alert-by-token)
</Card>

***

### PUT /anomaly\_alerts/{anomaly_alert_token}

**Update anomaly alert**

Update an AnomalyAlert.

#### Path Parameters

* **anomaly\_alert\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "status": string // required // The status of the Anomaly Alert,
  "feedback": string // Optional additional comments for why this alert is ignored
}
```

#### Responses

**200**: OK

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalyalerts/update-anomaly-alert](https://docs.vantage.sh/api/anomalyalerts/update-anomaly-alert)
</Card>

***

## AnomalyNotifications

### GET /anomaly\_notifications

**Get all anomaly notifications**

Return all Anomaly Notifications.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

* **workspace\_token** (string) - Optional: Filter by workspace token.

* **cost\_report\_token** (string) - Optional: Filter by Cost Report token.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalynotifications/get-all-anomaly-notifications](https://docs.vantage.sh/api/anomalynotifications/get-all-anomaly-notifications)
</Card>

***

### POST /anomaly\_notifications

**Create anomaly notification**

Create an Anomaly Notification for a Cost Report.

#### Request Body

```json theme={null}
{
  "cost_report_token": string // required // The token of the Cost Report that has the notification,
  "threshold": integer // The threshold amount that must be met for the notification to fire,
  "user_tokens": [string] // The tokens of the Users that receive the notification,
  "recipient_emails": [string] // Email addresses that receive the notification. Must be organization users, on the account's SSO domain, or an approved third-party service address,
  "recipient_channels": [string] // The Slack/MS Teams channels that receive the notification
}
```

#### Responses

**201**: Created

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalynotifications/create-anomaly-notification](https://docs.vantage.sh/api/anomalynotifications/create-anomaly-notification)
</Card>

***

### DELETE /anomaly\_notifications/{anomaly_notification_token}

**Delete anomaly notification**

Delete an Anomaly Notification.

#### Path Parameters

* **anomaly\_notification\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalynotifications/delete-anomaly-notification](https://docs.vantage.sh/api/anomalynotifications/delete-anomaly-notification)
</Card>

***

### GET /anomaly\_notifications/{anomaly_notification_token}

**Get anomaly notification by token**

Return an Anomaly Notification that the current API token has access to.

#### Path Parameters

* **anomaly\_notification\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalynotifications/get-anomaly-notification-by-token](https://docs.vantage.sh/api/anomalynotifications/get-anomaly-notification-by-token)
</Card>

***

### PUT /anomaly\_notifications/{anomaly_notification_token}

**Update anomaly notification**

Update an Anomaly Notification.

#### Path Parameters

* **anomaly\_notification\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "threshold": integer // The threshold amount that must be met for the notification to fire,
  "user_tokens": [string] // The tokens of the users that receive the notification,
  "recipient_emails": [string] // Email addresses that receive the notification. Must be organization users, on the account's SSO domain, or an approved third-party service address,
  "recipient_channels": [string] // The Slack/MS Teams channels that receive the notification
}
```

#### Responses

**200**: OK

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/anomalynotifications/update-anomaly-notification](https://docs.vantage.sh/api/anomalynotifications/update-anomaly-notification)
</Card>

***

## AuditLogs

### GET /audit\_logs

**Get all audit logs**

Return all AuditLogs.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. Defaults to 100. The maximum is 5000.

* **user** (integer (int32)) - Optional: Filter by personal or service API token that performed the action.

* **workspace\_token** (string) - Optional: Filter by workspace token.

* **action** (string) - Optional: Filter by action type.
  * Allowed values: `create`, `update`, `delete`

* **object\_name** (string) - Optional: Filter by object name.

* **source** (string) - Optional: Filter by source.
  * Allowed values: `console`, `api`, `finops_agent`

* **object\_type** (string) - Optional: Filter by object type.
  * Allowed values: `virtual_tag`, `cost_report`, `recommendation_commitment`, `segment`, `access_policy`

* **token** (string) - Optional: Filter by audit log token.

* **object\_token** (string) - Optional: Filter by object token (auditable\_token).

* **start\_date** (string (date)) - Optional: Filter by start date (ISO 8601 format, e.g., 2024-06-01).

* **end\_date** (string (date)) - Optional: Filter by end date (ISO 8601 format, e.g., 2024-06-01).

#### Responses

**200**: OK

**403**: Forbidden

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/auditlogs/get-all-audit-logs](https://docs.vantage.sh/api/auditlogs/get-all-audit-logs)
</Card>

***

### GET /audit\_logs/{audit_log_token}

**Get audit log by token**

Return a specific AuditLog.

#### Path Parameters

* **audit\_log\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**403**: Forbidden

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/auditlogs/get-audit-log-by-token](https://docs.vantage.sh/api/auditlogs/get-audit-log-by-token)
</Card>

***

## BillingProfiles

### GET /billing\_profiles

**Get all billing profiles**

Returns a list of billing profiles (MSP invoicing required).

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingprofiles/get-all-billing-profiles](https://docs.vantage.sh/api/billingprofiles/get-all-billing-profiles)
</Card>

***

### POST /billing\_profiles

**Create billing profile**

Create a billing profile (MSP invoicing required).

#### Request Body

```json theme={null}
{
  "nickname": string // required // Display name for the billing profile,
  "billing_information_attributes": { // Billing address and contact information
    "token": string,
    "company_name": string // Company name for billing,
    "country_code": string // ISO country code,
    "address_line_1": string // First line of billing address,
    "address_line_2": string // Second line of billing address,
    "city": string // City for billing address,
    "state": string // State or province for billing address,
    "postal_code": string // Postal or ZIP code,
    "billing_email": [string] // Array of billing email addresses
  },
  "business_information_attributes": { // Business information and custom fields
    "token": string,
    "metadata": { // Business metadata including custom fields
      "custom_fields": [ // Array of custom field objects
        {
          "name": string // Custom field name,
          "value": string // Custom field value
        }
      ]
    }
  },
  "banking_information_attributes": { // Banking details (MSP accounts only)
    "token": string,
    "bank_name": string // Name of the bank,
    "beneficiary_name": string // Name of the account beneficiary,
    "tax_id": string // Tax identification number,
    "secure_data": { // Encrypted banking details
      "account_number": string // Bank account number (US),
      "routing_number": string // Bank routing number (US),
      "iban": string // International Bank Account Number (EU),
      "swift_bic": string // SWIFT/BIC code (EU)
    }
  },
  "invoice_adjustment_attributes": { // Invoice adjustments (taxes, fees, etc.)
    "token": string,
    "adjustment_items": [ // Array of adjustment items
      {
        "name": string // required // Name of the adjustment,
        "adjustment_type": string // Type of adjustment. Allowed values: `charge`, `credit`, `discount`,
        "calculation_type": string // required // How the adjustment is calculated. Allowed values: `fixed`, `percentage`,
        "amount": number // required // Amount or percentage value
      }
    ]
  }
}
```

#### Responses

**201**: Created

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingprofiles/create-billing-profile](https://docs.vantage.sh/api/billingprofiles/create-billing-profile)
</Card>

***

### DELETE /billing\_profiles/{billing_profile_token}

**Delete billing profile**

Requires MSP invoicing to be enabled on the account.

#### Path Parameters

* **billing\_profile\_token** (path) (string) - **Required**

#### Responses

**204**: Billing Profile deleted successfully.

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingprofiles/delete-billing-profile](https://docs.vantage.sh/api/billingprofiles/delete-billing-profile)
</Card>

***

### GET /billing\_profiles/{billing_profile_token}

**Get billing profile by token**

Requires MSP invoicing to be enabled on the account.

#### Path Parameters

* **billing\_profile\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingprofiles/get-billing-profile-by-token](https://docs.vantage.sh/api/billingprofiles/get-billing-profile-by-token)
</Card>

***

### PUT /billing\_profiles/{billing_profile_token}

**Update billing profile**

Requires MSP invoicing to be enabled on the account.

#### Path Parameters

* **billing\_profile\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "nickname": string // Display name for the billing profile,
  "billing_information_attributes": { // Billing address and contact information
    "token": string,
    "company_name": string // Company name for billing,
    "country_code": string // ISO country code,
    "address_line_1": string // First line of billing address,
    "address_line_2": string // Second line of billing address,
    "city": string // City for billing address,
    "state": string // State or province for billing address,
    "postal_code": string // Postal or ZIP code,
    "billing_email": [string] // Array of billing email addresses
  },
  "business_information_attributes": { // Business information and custom fields
    "token": string,
    "metadata": { // Business metadata including custom fields
      "custom_fields": [ // Array of custom field objects
        {
          "name": string // Custom field name,
          "value": string // Custom field value
        }
      ]
    }
  },
  "banking_information_attributes": { // Banking details (MSP accounts only)
    "token": string,
    "bank_name": string // Name of the bank,
    "beneficiary_name": string // Name of the account beneficiary,
    "tax_id": string // Tax identification number,
    "secure_data": { // Encrypted banking details
      "account_number": string // Bank account number (US),
      "routing_number": string // Bank routing number (US),
      "iban": string // International Bank Account Number (EU),
      "swift_bic": string // SWIFT/BIC code (EU)
    }
  },
  "invoice_adjustment_attributes": { // Invoice adjustments (taxes, fees, etc.)
    "token": string,
    "adjustment_items": [ // Array of adjustment items
      {
        "name": string // required // Name of the adjustment,
        "adjustment_type": string // Type of adjustment. Allowed values: `charge`, `credit`, `discount`,
        "calculation_type": string // required // How the adjustment is calculated. Allowed values: `fixed`, `percentage`,
        "amount": number // required // Amount or percentage value
      }
    ]
  }
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingprofiles/update-billing-profile](https://docs.vantage.sh/api/billingprofiles/update-billing-profile)
</Card>

***

## BillingRules

### GET /billing\_rules

**Get all billing rules**

Returns a list of billing rules.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingrules/get-all-billing-rules](https://docs.vantage.sh/api/billingrules/get-all-billing-rules)
</Card>

***

### POST /billing\_rules

**Create billing rule**

Create a BillingRule.

#### Request Body

```json theme={null}
{
  "type": string // required // The type of the BillingRule. Note: the values are case insensitive. Allowed values: `exclusion`, `adjustment`, `credit`, `charge`, `custom`,
  "title": string // required // The title of the BillingRule,
  "start_period": string // The start period of the BillingRule. DEPRECATED: use start_date instead,
  "start_date": string // The start date of the BillingRule. ISO 8601 formatted,
  "end_date": string // The end date of the BillingRule. ISO 8601 formatted,
  "apply_to_all": boolean // Determines if the BillingRule applies to all current and future managed accounts,
  "charge_type": string // The charge type of the BillingRule. Required for Exclusion rules,
  "percentage": number // The percentage of the cost shown. Required for Adjustment rules. Example value: 75.0,
  "service": string // The service of the BillingRule. Required for Charge and Credit rules,
  "category": string // The category of the BillingRule. Required for Charge and Credit rules,
  "sub_category": string // The subcategory of the BillingRule. Required for Charge and Credit rules,
  "amount": number // The amount for the BillingRule. Required for Charge and Credit rules. Example value: 300,
  "sql_query": string // The SQL query for the BillingRule. Required for Custom rules. Example value: UPDATE costs SET costs.amount = costs.amount * 0.95
}
```

#### Responses

**201**: Created

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingrules/create-billing-rule](https://docs.vantage.sh/api/billingrules/create-billing-rule)
</Card>

***

### DELETE /billing\_rules/{billing_rule_token}

**Delete billing rule**

Delete a BillingRule.

#### Path Parameters

* **billing\_rule\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingrules/delete-billing-rule](https://docs.vantage.sh/api/billingrules/delete-billing-rule)
</Card>

***

### GET /billing\_rules/{billing_rule_token}

**Get billing rule by token**

Return a BillingRule.

#### Path Parameters

* **billing\_rule\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingrules/get-billing-rule-by-token](https://docs.vantage.sh/api/billingrules/get-billing-rule-by-token)
</Card>

***

### PUT /billing\_rules/{billing_rule_token}

**Update billing rule**

Update a BillingRule.

#### Path Parameters

* **billing\_rule\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the BillingRule,
  "charge_type": string // The charge type of the BillingRule,
  "percentage": number // The percentage of the cost shown. Example value: 75.0,
  "service": string // The service of the BillingRule,
  "category": string // The category of the BillingRule,
  "sub_category": string // The subcategory of the BillingRule,
  "start_period": string // The start period of the BillingRule,
  "amount": number // The credit amount for the BillingRule. Example value: 300,
  "start_date": string // The start date of the BillingRule. ISO 8601 formatted,
  "end_date": string // The end date of the BillingRule. ISO 8601 formatted,
  "apply_to_all": boolean // Determines if the BillingRule applies to all current and future managed accounts,
  "sql_query": string // The SQL query of the BillingRule
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/billingrules/update-billing-rule](https://docs.vantage.sh/api/billingrules/update-billing-rule)
</Card>

***

## BudgetAlerts

### GET /budget\_alerts

**Get all budget alerts**

Return all BudgetAlerts.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The number of results to return. The maximum is 1000.

* **workspace\_token** (string) - Optional: Filter by workspace token.

* **budget\_token** (string) - Optional: Filter by budget token.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgetalerts/get-all-budget-alerts](https://docs.vantage.sh/api/budgetalerts/get-all-budget-alerts)
</Card>

***

### POST /budget\_alerts

**Create budget alert**

Create a Budget Alert.

#### Request Body

```json theme={null}
{
  "budget_tokens": [string] // required // The tokens of the Budget that has the alert,
  "threshold": integer // required // The threshold amount that must be met for the alert to fire,
  "workspace_token": string // The token of the Workspace to add the BudgetAlert to. Required if the API token is associated with multiple Workspaces,
  "user_tokens": [string] // The tokens of the users that receive the alert,
  "recipient_emails": [string] // Email addresses that receive the alert. Must be organization users, on the account's SSO domain, or an approved third-party service address,
  "duration_in_days": string // required // The number of days from the start or end of the month to trigger the alert if the threshold is reached.  For the full month, pass an empty value,
  "period_to_track": string // The period tracked on the alert. Used with duration_in_days to determine the time window of the alert. Defaults to start_of_the_month if not passed. Possible values: start_of_the_month, end_of_the_month,
  "recipient_channels": [string] // The channels receiving the alerts. Requires an integration provider to be connected
}
```

#### Responses

**201**: Created

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgetalerts/create-budget-alert](https://docs.vantage.sh/api/budgetalerts/create-budget-alert)
</Card>

***

### DELETE /budget\_alerts/{budget_alert_token}

**Delete budget alert**

Delete a BudgetAlert.

#### Path Parameters

* **budget\_alert\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgetalerts/delete-budget-alert](https://docs.vantage.sh/api/budgetalerts/delete-budget-alert)
</Card>

***

### GET /budget\_alerts/{budget_alert_token}

**Get budget alert by token**

Return a BudgetAlert.

#### Path Parameters

* **budget\_alert\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgetalerts/get-budget-alert-by-token](https://docs.vantage.sh/api/budgetalerts/get-budget-alert-by-token)
</Card>

***

### PUT /budget\_alerts/{budget_alert_token}

**Update budget alert**

Updates an existing BudgetAlert.

#### Path Parameters

* **budget\_alert\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "budget_tokens": [string] // The tokens of the Budget that has the alert,
  "threshold": integer // The threshold amount that must be met for the alert to fire,
  "workspace_token": string // The token of the Workspace the BudgetAlert belongs to. Required if the API token is associated with multiple Workspaces,
  "user_tokens": [string] // The tokens of the users that receive the alert,
  "recipient_emails": [string] // Email addresses that receive the alert. Must be organization users, on the account's SSO domain, or an approved third-party service address,
  "duration_in_days": string // The number of days from the start or end of the month to trigger the alert if the threshold is reached. For the full month, pass an empty value,
  "period_to_track": string // The period tracked on the alert. Used with duration_in_days to determine the time window of the alert. Defaults to start_of_the_month if not passed. Possible values: start_of_the_month, end_of_the_month,
  "recipient_channels": [string] // The channels receiving the alerts. Requires an integration provider to be connected
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgetalerts/update-budget-alert](https://docs.vantage.sh/api/budgetalerts/update-budget-alert)
</Card>

***

## Budgets

### GET /budgets

**Get all budgets**

Return all Budgets.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The number of results to return. The maximum is 1000.

* **q** (string) - Optional: Search budgets by name.

* **workspace\_token** (string) - Optional: The workspace token of the budgets to return.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgets/get-all-budgets](https://docs.vantage.sh/api/budgets/get-all-budgets)
</Card>

***

### POST /budgets

**Create budget**

Create a Budget.

#### Request Body

```json theme={null}
{
  "name": string // required // The name of the Budget,
  "workspace_token": string // The token of the Workspace to add the Budget to,
  "cost_report_token": string // The CostReport token. Ignored for hierarchical Budgets,
  "type": string // The type of Budget. One of: cost, usage. Allowed values: `cost`, `usage`,
  "unit": string // The usage unit for usage Budgets,
  "child_budget_tokens": [string] // The tokens of any child Budgets when creating a hierarchical Budget. Child budgets must share the same current period dates,
  "period_cadence": { // The interval cadence for budget periods
    "starts_at": string // required // The anchor date for budget period intervals. Send null to clear,
    "interval_count": integer // The number of interval units per budget period,
    "interval_unit": string // The unit for budget period intervals. One of: day, week, month, year. Allowed values: `day`, `week`, `month`, `year`
  },
  "periods": [ // The periods for the Budget. The start_at and end_at must be iso8601 formatted e.g. YYYY-MM-DD. Ignored for hierarchical Budgets
    {
      "start_at": string // required // The start date of the period,
      "end_at": string // The end date of the period,
      "amount": number // required // The amount of the period
    }
  ]
}
```

#### Responses

**201**: Created

**400**: BadRequest

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgets/create-budget](https://docs.vantage.sh/api/budgets/create-budget)
</Card>

***

### DELETE /budgets/{budget_token}

**Delete budget**

Delete a Budget.

#### Path Parameters

* **budget\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgets/delete-budget](https://docs.vantage.sh/api/budgets/delete-budget)
</Card>

***

### GET /budgets/{budget_token}

**Get budget by token**

Return a Budget.

#### Path Parameters

* **budget\_token** (path) (string) - **Required**

#### Query Parameters

* **include\_performance** (boolean) - Optional: Include performance data.

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgets/get-budget-by-token](https://docs.vantage.sh/api/budgets/get-budget-by-token)
</Card>

***

### PUT /budgets/{budget_token}

**Update budget**

Update a Budget.

#### Path Parameters

* **budget\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "name": string // The name of the Budget,
  "cost_report_token": string // The CostReport token. Ignored for hierarchical Budgets,
  "type": string // The type of Budget. One of: cost, usage. Allowed values: `cost`, `usage`,
  "unit": string // The usage unit for usage Budgets. Send null to clear,
  "child_budget_tokens": [string] // The tokens of any child Budgets when creating a hierarchical Budget. Child budgets must share the same current period dates. Omitted on update to leave the current child list unchanged,
  "period_cadence": { // The interval cadence for budget periods. Changing cadence after creation is rejected
    "starts_at": string // required // The anchor date for budget period intervals. Send null to clear,
    "interval_count": integer // The number of interval units per budget period,
    "interval_unit": string // The unit for budget period intervals. One of: day, week, month, year. Allowed values: `day`, `week`, `month`, `year`
  },
  "periods": [ // The periods for the Budget. The start_at and end_at must be iso8601 formatted e.g. YYYY-MM-DD. Ignored for hierarchical Budgets
    {
      "start_at": string // required // The start date of the period,
      "end_at": string // The end date of the period,
      "amount": number // required // The amount of the period
    }
  ]
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/budgets/update-budget](https://docs.vantage.sh/api/budgets/update-budget)
</Card>

***

## BusinessMetrics

### GET /business\_metrics

**Get all business metrics**

Return all BusinessMetrics that the current API token has access to.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 5000.

* **q** (string) - Optional: Search business metrics by title.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/get-all-business-metrics](https://docs.vantage.sh/api/businessmetrics/get-all-business-metrics)
</Card>

***

### POST /business\_metrics

**Create business metric**

Create a new BusinessMetric.

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the BusinessMetrics,
  "cost_report_tokens_with_metadata": [ // The tokens for any CostReports that use the BusinessMetric, the unit scale, and label filter
    {
      "cost_report_token": string // required // The token of the CostReport the BusinessMetric is attached to,
      "unit_scale": string // Determines the scale of the BusinessMetric's values within the CostReport. Allowed values: `per_unit`, `per_hundred`, `per_thousand`, `per_million`, `per_billion`,
      "calculation_type": string // The calculation type applied when this BusinessMetric is used in the CostReport. Allowed values: `unit_cost`, `gross_margin`, `usage_unit_cost`, `raw_business_metric`,
      "label": string // Optional custom display name for this BusinessMetric on the CostReport. When omitted, a default is derived from the calculation type,
      "label_filter": [string] // Include only values with these labels in the CostReport,
      "label_filters": object // Include only ClickHouse BusinessMetric values matching every label key and one of its values
    }
  ],
  "values": [ // The dates, amounts, and (optional) labels for the BusinessMetric
    {
      "date": string // required,
      "amount": number // required,
      "label": string
    }
  ],
  "forecasted_values": [ // The dates, amounts, and (optional) labels for forecasted BusinessMetric values
    {
      "date": string // required,
      "amount": number // required,
      "label": string
    }
  ],
  "datadog_metric_fields": { // Datadog metric configuration fields
    "integration_token": string // Integration token for the account from which you would like to fetch metrics,
    "query": string // Datadog metrics query string. e.g. sum:aws.applicationelb.request_count{region:us-east-1}.rollup(avg,daily)
  },
  "cloudwatch_fields": { // Cloudwatch configuration fields
    "integration_token": string // Integration token for the account from which you would like to fetch metrics,
    "stat": string,
    "region": string,
    "namespace": string,
    "metric_name": string,
    "label_dimension": string,
    "dimensions": [
      {
        "name": string,
        "value": string
      }
    ]
  },
  "gcp_bigquery_metric_fields": { // GCP BigQuery metric configuration fields
    "integration_token": string // Integration token for the GCP integration from which you would like to fetch metrics,
    "query_project_id": string // GCP project in which the BigQuery job should run,
    "sql_query": string // BigQuery SQL query returning date, value, and optional label columns
  },
  "snowflake_metric_fields": { // Snowflake metric configuration fields
    "integration_token": string // Integration token for the Snowflake integration from which you would like to fetch metrics,
    "sql_query": string // Snowflake SQL query returning date, value, and optional label columns
  },
  "clickhouse_metric_fields": { // ClickHouse metric configuration fields
    "integration_token": string // Integration token for the ClickHouse integration from which you would like to fetch metrics,
    "query_endpoint_id": string // UUID of the ClickHouse query endpoint used to fetch metrics
  }
}
```

#### Responses

**201**: Created

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/create-business-metric](https://docs.vantage.sh/api/businessmetrics/create-business-metric)
</Card>

***

### DELETE /business\_metrics/{business_metric_token}

**Delete business metric**

Deletes an existing BusinessMetric.

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**403**: Forbidden

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/delete-business-metric](https://docs.vantage.sh/api/businessmetrics/delete-business-metric)
</Card>

***

### GET /business\_metrics/{business_metric_token}

**Get business metric by token**

Return a BusinessMetric.

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/get-business-metric-by-token](https://docs.vantage.sh/api/businessmetrics/get-business-metric-by-token)
</Card>

***

### PUT /business\_metrics/{business_metric_token}

**Update business metric**

Updates an existing BusinessMetric.

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the BusinessMetric,
  "cost_report_tokens_with_metadata": [ // The tokens for any CostReports that use the BusinessMetric, and the unit scale
    {
      "cost_report_token": string // required // The token of the CostReport the BusinessMetric is attached to,
      "unit_scale": string // Determines the scale of the BusinessMetric's values within the CostReport. Allowed values: `per_unit`, `per_hundred`, `per_thousand`, `per_million`, `per_billion`,
      "calculation_type": string // The calculation type applied when this BusinessMetric is used in the CostReport. Allowed values: `unit_cost`, `gross_margin`, `usage_unit_cost`, `raw_business_metric`,
      "label": string // Optional custom display name for this BusinessMetric on the CostReport. When omitted, a default is derived from the calculation type,
      "label_filter": [string] // Include only values with these labels in the CostReport,
      "label_filters": object // Include only ClickHouse BusinessMetric values matching every label key and one of its values
    }
  ],
  "values": [ // The dates, amounts, and (optional) labels for the BusinessMetric
    {
      "date": string // required,
      "amount": number // required,
      "label": string
    }
  ],
  "forecasted_values": [ // The dates, amounts, and (optional) labels for forecasted BusinessMetric values
    {
      "date": string // required,
      "amount": number // required,
      "label": string
    }
  ],
  "datadog_metric_fields": { // Datadog metric configuration fields
    "integration_token": string // Integration token for the account from which you would like to fetch metrics,
    "query": string // Datadog metrics query string. e.g. sum:aws.applicationelb.request_count{region:us-east-1}.rollup(avg,daily)
  },
  "cloudwatch_fields": { // Cloudwatch configuration fields
    "integration_token": string // Integration token for the account from which you would like to fetch metrics,
    "stat": string,
    "region": string,
    "namespace": string,
    "metric_name": string,
    "label_dimension": string,
    "dimensions": [
      {
        "name": string,
        "value": string
      }
    ]
  },
  "snowflake_metric_fields": { // Snowflake metric configuration fields
    "integration_token": string // Integration token for the Snowflake integration from which you would like to fetch metrics,
    "sql_query": string // Snowflake SQL query returning date, value, and optional label columns
  }
}
```

#### Responses

**200**: OK

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/update-business-metric](https://docs.vantage.sh/api/businessmetrics/update-business-metric)
</Card>

***

### GET /business\_metrics/{business_metric_token}/forecasted\_values

**Get business metric forecasted values**

Return forecasted values of a BusinessMetric

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 5000.

* **start\_date** (string (date)) - Optional: Query BusinessMetrics by the first date you would like to filter from. ISO 8601 Formatted - 2021-07-15

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/get-business-metric-forecasted-values](https://docs.vantage.sh/api/businessmetrics/get-business-metric-forecasted-values)
</Card>

***

### GET /business\_metrics/{business_metric_token}/labels

**Get business metric labels**

Return labels of a BusinessMetric.

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.
  * Default: `1`

* **limit** (integer (int32)) - Optional: The number of results to return per page. Defaults to 1000. The maximum is 5000.
  * Default: `1000`

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/get-business-metric-labels](https://docs.vantage.sh/api/businessmetrics/get-business-metric-labels)
</Card>

***

### DELETE /business\_metrics/{business_metric_token}/values

**Delete business metric values**

Deletes Business Metric values (historical or forecasted unit metrics). BusinessMetrics whose values are stored in ClickHouse only support deleting every historical value or every forecasted value, so supplying start\_date, end\_date, or label returns 422.

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Query Parameters

* **start\_date** (string) - Optional: Inclusive lower bound (ISO 8601 date or datetime, UTC). Date-only values start at 00:00:00 UTC that day.

* **end\_date** (string) - Optional: Inclusive upper bound (ISO 8601 date or datetime, UTC). Date-only values include the full calendar day through 23:59:59.999999999 UTC.

* **label** (string) - Optional: When present in the query string (including as an empty value), only unit metrics with this exact label are deleted. Omit the parameter to delete all labels in range.

* **forecasted** (boolean) - Optional: When true, deletes forecasted unit metrics instead of historical ones.
  * Default: `False`

#### Responses

**200**: OK

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/delete-business-metric-values](https://docs.vantage.sh/api/businessmetrics/delete-business-metric-values)
</Card>

***

### GET /business\_metrics/{business_metric_token}/values

**Get business metric values**

Return values of a BusinessMetric

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 5000.

* **start\_date** (string (date)) - Optional: Query BusinessMetrics by the first date you would like to filter from. ISO 8601 Formatted - 2021-07-15

* **label\_values** (array) - Optional: Return values matching any exact label value. For multi-label metrics, matches values under any label key.

* **date\_bin** (string) - Optional: Sum values by UTC day or month while preserving labels. When omitted, values are returned without aggregation.
  * Allowed values: `day`, `month`

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/get-business-metric-values](https://docs.vantage.sh/api/businessmetrics/get-business-metric-values)
</Card>

***

### PUT /business\_metrics/{business_metric_token}/values.csv

**Update business metric values from CSV**

Updates the values for an existing BusinessMetric from a CSV file.

#### Path Parameters

* **business\_metric\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**400**: BadRequest

**403**: Forbidden

**404**: NotFound

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/businessmetrics/update-business-metric-values-from-csv](https://docs.vantage.sh/api/businessmetrics/update-business-metric-values-from-csv)
</Card>

***

## Canvases

### GET /canvases

**Get all canvases**

Return all Canvases.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

* **workspace\_token** (string) - Optional: Filter by workspace token.

* **q** (string) - Optional: Search canvases by title.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/canvases/get-all-canvases](https://docs.vantage.sh/api/canvases/get-all-canvases)
</Card>

***

### POST /canvases

**Create canvas**

Create a Canvas.

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the Canvas,
  "prompt": string // required // The prompt used to generate the Canvas,
  "workspace_token": string // The token of the Workspace to add the Canvas to. Required if the API token is associated with multiple Workspaces
}
```

#### Responses

**201**: Created

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/canvases/create-canvas](https://docs.vantage.sh/api/canvases/create-canvas)
</Card>

***

### DELETE /canvases/{canvas_token}

**Delete canvas**

Delete a Canvas.

#### Path Parameters

* **canvas\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/canvases/delete-canvas](https://docs.vantage.sh/api/canvases/delete-canvas)
</Card>

***

### GET /canvases/{canvas_token}

**Get canvas by token**

Return a specific Canvas.

#### Path Parameters

* **canvas\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/canvases/get-canvas-by-token](https://docs.vantage.sh/api/canvases/get-canvas-by-token)
</Card>

***

### PUT /canvases/{canvas_token}

**Update canvas**

Update a Canvas.

#### Path Parameters

* **canvas\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the Canvas,
  "prompt": string // The prompt used to generate the Canvas
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/canvases/update-canvas](https://docs.vantage.sh/api/canvases/update-canvas)
</Card>

***

## CostAlertEvents

### GET /cost\_alerts/{cost_alert_token}/events

**Get all cost alert events**

Get all CostAlertEvents

#### Path Parameters

* **cost\_alert\_token** (path) (string) - **Required**: The token of the CostAlertEvent.

#### Query Parameters

* **report\_token** (string) - Optional: The token of the report associated with the CostAlertEvent.

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The number of results to return. The maximum is 1000.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalertevents/get-all-cost-alert-events](https://docs.vantage.sh/api/costalertevents/get-all-cost-alert-events)
</Card>

***

### GET /cost\_alerts/{cost_alert_token}/events/{event_token}

**Get cost alert event by token**

Get a CostAlertEvent

#### Path Parameters

* **cost\_alert\_token** (path) (string) - **Required**

* **event\_token** (path) (string) - **Required**

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalertevents/get-cost-alert-event-by-token](https://docs.vantage.sh/api/costalertevents/get-cost-alert-event-by-token)
</Card>

***

## CostAlerts

### GET /cost\_alerts

**Get all cost alerts**

List all Cost Alerts

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 5000.

* **q** (string) - Optional: Search cost alerts by title.

* **workspace\_token** (string) - Optional: The workspace token of the cost alerts to return.

#### Responses

**200**: List all Cost Alerts

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalerts/get-all-cost-alerts](https://docs.vantage.sh/api/costalerts/get-all-cost-alerts)
</Card>

***

### POST /cost\_alerts

**Create cost alert**

Create a new Cost Alert

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the Cost Alert,
  "interval": string // required // The period of time used to compare costs. Options are 'day', 'week', 'month', 'quarter',
  "threshold": number // required // The threshold value for the Cost Alert,
  "unit_type": string // required // The unit type used to compare costs. Options are 'currency' or 'percentage',
  "workspace_token": string // required // The token of the Workspace to add the Cost Alert to,
  "report_tokens": [string] // required // The tokens of the reports to alert on,
  "email_recipients": [string] // The email recipients for the Cost Alert. Accepts organization users, SSO-domain emails, and approved third-party service emails,
  "slack_channels": [string] // The Slack channels that will receive the alert,
  "teams_channels": [string] // The Microsoft Teams channels that will receive the alert,
  "minimum_threshold": number // The minimum monetary amount threshold for percentage-based alerts. Only applicable when unit_type is 'percentage'
}
```

#### Responses

**201**: Cost Alert created successfully.

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalerts/create-cost-alert](https://docs.vantage.sh/api/costalerts/create-cost-alert)
</Card>

***

### DELETE /cost\_alerts/{cost_alert_token}

**Delete cost alert**

Delete a Cost Alert

#### Path Parameters

* **cost\_alert\_token** (path) (string) - **Required**: The token of the Cost Alert.

#### Responses

**204**: Cost Alert deleted successfully.

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalerts/delete-cost-alert](https://docs.vantage.sh/api/costalerts/delete-cost-alert)
</Card>

***

### GET /cost\_alerts/{cost_alert_token}

**Get cost alert by token**

Get a Cost Alert

#### Path Parameters

* **cost\_alert\_token** (path) (string) - **Required**: The token of the Cost Alert.

#### Responses

**200**: Get a Cost Alert

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalerts/get-cost-alert-by-token](https://docs.vantage.sh/api/costalerts/get-cost-alert-by-token)
</Card>

***

### PUT /cost\_alerts/{cost_alert_token}

**Update cost alert**

Update a Cost Alert

#### Path Parameters

* **cost\_alert\_token** (path) (string) - **Required**: The token of the Cost Alert.

#### Request Body

```json theme={null}
{
  "title": string // The title of the Cost Alert,
  "email_recipients": [string] // The email recipients for the Cost Alert. Accepts organization users, SSO-domain emails, and approved third-party service emails,
  "interval": string // The period of time used to compare costs. Options are 'day', 'week', 'month', 'quarter',
  "threshold": number // The threshold value for the Cost Alert,
  "slack_channels": [string] // The Slack channels that will receive the alert. Make sure your slack integration is connected at https://console.vantage.sh/settings/slack,
  "teams_channels": [string] // The Microsoft Teams channels that will receive the alert. Make sure your teams integration is connected at https://console.vantage.sh/settings/microsoft_teams,
  "unit_type": string // The unit type used to compare costs. Options are 'currency' or 'percentage',
  "report_tokens": [string] // The tokens of the reports to alert on,
  "minimum_threshold": number // The minimum monetary amount threshold for percentage-based alerts. Only applicable when unit_type is 'percentage'
}
```

#### Responses

**200**: Cost Alert updated successfully.

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costalerts/update-cost-alert](https://docs.vantage.sh/api/costalerts/update-cost-alert)
</Card>

***

## CostProvider

### GET /cost\_providers

**Get cost providers**

List CostProviders available to query in a given Workspace.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The number of results to return. The maximum is 1000.

* **workspace\_token** (string) - Optional: The token of the Workspace to list CostProviders for. Required if the API token is associated with multiple Workspaces.

* **q** (string) - Optional: Search CostProviders by name or key.

#### Responses

**200**: List of connected CostProviders.

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costprovider/get-cost-providers](https://docs.vantage.sh/api/costprovider/get-cost-providers)
</Card>

***

## CostProviderAccounts

### GET /cost\_provider\_accounts

**Get all cost provider accounts**

List CostProviderAccounts available in a given Workspace.

#### Query Parameters

* **workspace\_token** (string) - Optional: The token of the Workspace to list CostProviderAccounts for. Required if the API token is associated with multiple Workspaces.

* **provider** (string) - Optional: Filter by provider type.
  * Allowed values: `aws`, `azure`, `gcp`, `snowflake`, `databricks`, `mongo`, `datadog`, `fastly`, `new_relic`, `opencost`, `open_ai`, `oracle`, `confluent`, `planetscale`, `coralogix`, `kubernetes`, `custom_provider`, `github`, `linode`, `grafana`, `clickhouse`, `temporal`, `twilio`, `azure_csp`, `kubernetes_agent`, `anthropic`, `anyscale`, `cursor`, `elastic`, `vercel`, `redis_cloud`, `circle_ci`, `modal`, `eleven_labs`, `baseten`, `cloudflare`, `fireworks_ai`, `cartesia`, `depot`, `xai`, `digital_ocean`, `together_ai`, `coreweave`, `devin`, `openrouter`, `deepgram`, `crusoe`, `sentry_billing`, `ramp`

* **account\_id** (string) - Optional: Filter by provider account identifier.

* **account\_name** (string) - Optional: Filter by account name (exact match).

* **q** (string) - Optional: Search CostProviderAccounts by title.

#### Responses

**200**: List of provider accounts.

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costprovideraccounts/get-all-cost-provider-accounts](https://docs.vantage.sh/api/costprovideraccounts/get-all-cost-provider-accounts)
</Card>

***

## CostService

### GET /cost\_services

**Get cost services**

List CostServices available to query in a given Workspace.

#### Query Parameters

* **workspace\_token** (string) - Optional: The token of the Workspace to list CostServices for. Required if the API token is associated with multiple Workspaces.

#### Responses

**200**: List of CostServices, used to query costs using VQL.

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costservice/get-cost-services](https://docs.vantage.sh/api/costservice/get-cost-services)
</Card>

***

## Costs

### GET /cost\_reports

**Get all cost reports**

Return all CostReports.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

* **folder\_token** (string) - Optional: The token for the Folder you would like to fetch Reports from.

* **q** (string) - Optional: Search cost reports by title.

* **workspace\_token** (string) - Optional: The workspace token of the cost reports to return.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/get-all-cost-reports](https://docs.vantage.sh/api/costs/get-all-cost-reports)
</Card>

***

### POST /cost\_reports

**Create cost report**

Create a CostReport.

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the CostReport,
  "workspace_token": string // The token of the Workspace to add the Cost Report to. Ignored if 'folder_token' is set. Required if the API token is associated with multiple Workspaces,
  "groupings": string // Grouping values for aggregating costs on the report. Valid groupings: account_id, billing_account_id, charge_type, cost_category, cost_subcategory, provider, region, resource_id, service, tagged, usage_unit, tag:tag_value. If providing multiple groupings, join as comma separated values: groupings=provider,service,region,
  "filter": string // The filter query language to apply to the CostReport. Additional documentation available at https://docs.vantage.sh/vql,
  "saved_filter_tokens": [string] // The tokens of the SavedFilters to apply to the CostReport,
  "business_metric_tokens_with_metadata": [ // The tokens for any BusinessMetrics to attach to the CostReport, and the unit scale
    {
      "business_metric_token": string // required // The token of the BusinessMetric to attach to the CostReport,
      "unit_scale": string // Determines the scale of the BusinessMetric's values within the CostReport. Allowed values: `per_unit`, `per_hundred`, `per_thousand`, `per_million`, `per_billion`,
      "calculation_type": string // The calculation type applied when this BusinessMetric is used in the CostReport. Allowed values: `unit_cost`, `gross_margin`, `usage_unit_cost`, `raw_business_metric`,
      "label": string // Optional custom display name for this BusinessMetric on the CostReport. When omitted, a default is derived from the calculation type,
      "label_filter": [string] // Include only values with these labels in the CostReport,
      "label_filters": object // Include only ClickHouse BusinessMetric values matching every label key and one of its values
    }
  ],
  "folder_token": string // The token of the Folder to add the CostReport to. Determines the Workspace the report is assigned to,
  "settings": { // Report settings
    "include_credits": boolean // Report will include credits,
    "include_refunds": boolean // Report will include refunds,
    "include_discounts": boolean // Report will include discounts,
    "include_tax": boolean // Report will include tax,
    "amortize": boolean // Report will amortize,
    "unallocated": boolean // Report will show unallocated costs,
    "aggregate_by": string // Report will aggregate by cost, usage, or count. Allowed values: `cost`, `usage`, `count`,
    "show_previous_period": boolean // Report will show previous period cost, usage, or count comparison,
    "complete_period": boolean // Report will restrict date ranges to completed periods only
  },
  "previous_period_start_date": string // The previous period start date of the CostReport. ISO 8601 Formatted,
  "previous_period_end_date": string // required // The previous period end date of the CostReport. ISO 8601 Formatted. Required when previous_period_start_date is provided,
  "start_date": string // The start date of the CostReport. ISO 8601 Formatted. Incompatible with 'date_interval' parameter,
  "end_date": string // required // The end date of the CostReport. ISO 8601 Formatted. Required when start_date is provided. Incompatible with 'date_interval' parameter,
  "date_interval": string // The date interval of the CostReport. Incompatible with 'start_date' and 'end_date' parameters. Defaults to 'this_month' if start_date and end_date are not provided. Allowed values: `this_month`, `last_7_days`, `last_30_days`, `last_month`, `last_3_months`, `last_6_months`, `custom`, `last_12_months`, `last_24_months`, `last_36_months`, `next_month`, `next_3_months`, `next_6_months`, `next_12_months`, `year_to_date`, `last_3_days`, `last_14_days`,
  "chart_type": string // The chart type of the CostReport. Allowed values: `area`, `line`, `pie`, `bar`, `multi_bar`,
  "date_bin": string // The date bin of the CostReport. Allowed values: `cumulative`, `day`, `week`, `month`, `quarter`, `hour`,
  "chart_settings": { // Report chart settings
    "x_axis_dimension": [string] // The dimension used to group or label data along the x-axis (e.g., by date, region, or service). NOTE: Only one value is allowed at this time. Defaults to ['date'],
    "y_axis_dimension": string // The metric or measure displayed on the chart’s y-axis. Possible values: 'cost', 'usage', 'count'. Defaults to 'cost'. Allowed values: `cost`, `usage`, `count`
  }
}
```

#### Responses

**201**: Created

**400**: BadRequest

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/create-cost-report](https://docs.vantage.sh/api/costs/create-cost-report)
</Card>

***

### DELETE /cost\_reports/{cost_report_token}

**Delete cost report**

Delete a CostReport.

#### Path Parameters

* **cost\_report\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/delete-cost-report](https://docs.vantage.sh/api/costs/delete-cost-report)
</Card>

***

### GET /cost\_reports/{cost_report_token}

**Get cost report by token**

Return a CostReport.

#### Path Parameters

* **cost\_report\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/get-cost-report-by-token](https://docs.vantage.sh/api/costs/get-cost-report-by-token)
</Card>

***

### PUT /cost\_reports/{cost_report_token}

**Update cost report**

Update a CostReport.

#### Path Parameters

* **cost\_report\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the CostReport,
  "groupings": string // Grouping values for aggregating costs on the report. Valid groupings: account_id, billing_account_id, charge_type, cost_category, cost_subcategory, provider, region, resource_id, service, tagged, usage_unit, tag:tag_value. If providing multiple groupings, join as comma separated values: groupings=provider,service,region,
  "filter": string // The filter query language to apply to the CostReport. Additional documentation available at https://docs.vantage.sh/vql,
  "saved_filter_tokens": [string] // The tokens of the SavedFilters to apply to the CostReport,
  "business_metric_tokens_with_metadata": [ // The tokens for any BusinessMetrics to attach to the CostReport, and the unit scale
    {
      "business_metric_token": string // required // The token of the BusinessMetric to attach to the CostReport,
      "unit_scale": string // Determines the scale of the BusinessMetric's values within the CostReport. Allowed values: `per_unit`, `per_hundred`, `per_thousand`, `per_million`, `per_billion`,
      "calculation_type": string // The calculation type applied when this BusinessMetric is used in the CostReport. Allowed values: `unit_cost`, `gross_margin`, `usage_unit_cost`, `raw_business_metric`,
      "label": string // Optional custom display name for this BusinessMetric on the CostReport. When omitted, a default is derived from the calculation type,
      "label_filter": [string] // Include only values with these labels in the CostReport,
      "label_filters": object // Include only ClickHouse BusinessMetric values matching every label key and one of its values
    }
  ],
  "folder_token": string // The token of the Folder to add the CostReport to. Determines the Workspace the report is assigned to,
  "default_forecast": { // The default forecast selection for the CostReport
    "kind": string // required // The default forecast selection kind. Allowed values: `baseline`, `report_forecast`,
    "report_forecast_token": string // The token for the report forecast to set as default when kind is report_forecast
  },
  "settings": { // Report settings
    "include_credits": boolean // Report will include credits,
    "include_refunds": boolean // Report will include refunds,
    "include_discounts": boolean // Report will include discounts,
    "include_tax": boolean // Report will include tax,
    "amortize": boolean // Report will amortize,
    "unallocated": boolean // Report will show unallocated costs,
    "aggregate_by": string // Report will aggregate by cost, usage, or count. Allowed values: `cost`, `usage`, `count`,
    "show_previous_period": boolean // Report will show previous period cost, usage, or count comparison,
    "complete_period": boolean // Report will restrict date ranges to completed periods only
  },
  "chart_settings": { // Report chart settings
    "x_axis_dimension": [string] // The dimension used to group or label data along the x-axis (e.g., by date, region, or service). NOTE: Only one value is allowed at this time. Defaults to ['date'],
    "y_axis_dimension": string // The metric or measure displayed on the chart’s y-axis. Possible values: 'cost', 'usage', 'count'. Defaults to 'cost'. Allowed values: `cost`, `usage`, `count`
  },
  "previous_period_start_date": string // The previous period start date of the CostReport. ISO 8601 Formatted,
  "previous_period_end_date": string // The previous period end date of the CostReport. ISO 8601 Formatted. Required when previous_period_start_date is provided,
  "start_date": string // The start date of the CostReport. ISO 8601 Formatted. Incompatible with 'date_interval' parameter,
  "end_date": string // The end date of the CostReport. ISO 8601 Formatted. Required when start_date is provided. Incompatible with 'date_interval' parameter,
  "date_interval": string // The date interval of the CostReport. Incompatible with 'start_date' and 'end_date' parameters. Defaults to 'this_month' if start_date and end_date are not provided. Allowed values: `this_month`, `last_7_days`, `last_30_days`, `last_month`, `last_3_months`, `last_6_months`, `custom`, `last_12_months`, `last_24_months`, `last_36_months`, `next_month`, `next_3_months`, `next_6_months`, `next_12_months`, `year_to_date`, `last_3_days`, `last_14_days`,
  "chart_type": string // The chart type of the CostReport. Allowed values: `area`, `line`, `pie`, `bar`, `multi_bar`,
  "date_bin": string // The date bin of the CostReport. Allowed values: `cumulative`, `day`, `week`, `month`, `quarter`, `hour`
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/update-cost-report](https://docs.vantage.sh/api/costs/update-cost-report)
</Card>

***

### GET /cost\_reports/{cost_report_token}/forecasted\_costs

**Get forecasted costs for a cost report**

Return all ForecastedCosts.

#### Path Parameters

* **cost\_report\_token** (path) (string) - **Required**

#### Query Parameters

* **start\_date** (string (date)) - Optional: First date you would like to filter forecasted costs from. ISO 8601 formatted.

* **end\_date** (string (date)) - Optional: Last date you would like to filter forecasted costs from. ISO 8601 formatted.

* **provider** (string) - Optional: Limit the forecasted costs to a specific provider. 'all' is accepted to filter to overall forecast.
  * Allowed values: `aws`, `azure`, `gcp`, `snowflake`, `databricks`, `mongo`, `datadog`, `fastly`, `new_relic`, `opencost`, `open_ai`, `oracle`, `confluent`, `planetscale`, `coralogix`, `kubernetes`, `custom_provider`, `github`, `linode`, `grafana`, `clickhouse`, `temporal`, `twilio`, `azure_csp`, `kubernetes_agent`, `anthropic`, `anyscale`, `cursor`, `elastic`, `vercel`, `redis_cloud`, `circle_ci`, `modal`, `eleven_labs`, `baseten`, `cloudflare`, `fireworks_ai`, `cartesia`, `depot`, `xai`, `digital_ocean`, `together_ai`, `coreweave`, `devin`, `openrouter`, `deepgram`, `crusoe`, `sentry_billing`, `ramp`, `all`

* **service** (string) - Optional: Limit the forecasted costs to a specific service. 'all' is accepted to filter to overall forecast. e.g. 'Amazon ElastiCache'.

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/get-forecasted-costs-for-a-cost-report](https://docs.vantage.sh/api/costs/get-forecasted-costs-for-a-cost-report)
</Card>

***

### GET /costs

**Get costs for cost report or VQL filter**

Return all Costs for a CostReport or VQL filter.

#### Query Parameters

* **cost\_report\_token** (string) - Optional: The CostReport token.

* **filter** (string) - Optional: The VQL filter to apply to the costs. If this is supplied you do not need cost\_report\_token.

* **workspace\_token** (string) - Optional: The token of the Workspace to query costs from. Ignored if 'cost\_report\_token' is set. Required if the API token is associated with multiple Workspaces.

* **start\_date** (string) - Optional: First date you would like to filter costs from. ISO 8601 formatted. When omitted with cost\_report\_token, the report's saved start date is used.

* **end\_date** (string) - Optional: Last date you would like to filter costs to. ISO 8601 formatted. When omitted with cost\_report\_token, the report's saved end date is used.

* **groupings** (array) - Optional: Group the results by specific field(s). When omitted with cost\_report\_token, the report's saved groupings are used; otherwise defaults to provider, service, account\_id. Valid groupings: account\_id, billing\_account\_id, charge\_type, cost\_category, cost\_subcategory, provider, region, resource\_id, service, tagged, usage\_unit, tag:tag\_value. If providing multiple groupings, join as comma separated values: groupings=provider,service,region

* **order** (string) - Optional: Whether to order costs by date in ascending or descending order. Defaults to desc.
  * Allowed values: `asc`, `desc`
  * Default: `desc`

* **sort\_column** (string) - Optional: Sort results by one of the fields in groupings. Valid groupings: account\_id, billing\_account\_id, charge\_type, cost\_category, cost\_subcategory, provider, region, resource\_id, service, tagged, usage\_unit, tag:tag\_value. Defaults to sorting by date.

* **sort\_direction** (string) - Optional: Sort direction for sort\_column. Defaults to asc. Requires sort\_column.
  * Allowed values: `asc`, `desc`

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 5000.

* **page** (integer (int32)) - Optional: The page of results to return.

* **date\_bin** (string) - Optional: The date bin of the costs. Defaults to the report's default or day.
  * Allowed values: `day`, `week`, `month`, `quarter`, `hour`

* **settings\[include\_credits]** (boolean) - Optional: Results will include credits.

* **settings\[include\_refunds]** (boolean) - Optional: Results will include refunds.

* **settings\[include\_discounts]** (boolean) - Optional: Results will include discounts.

* **settings\[include\_tax]** (boolean) - Optional: Results will include tax.

* **settings\[amortize]** (boolean) - Optional: Results will amortize.

* **settings\[unallocated]** (boolean) - Optional: Results will show unallocated costs.

* **settings\[aggregate\_by]** (string) - Optional: Results will aggregate by cost, usage, or count.
  * Allowed values: `cost`, `usage`, `count`

* **settings\[show\_previous\_period]** (boolean) - Optional: Results will show previous period cost, usage, or count comparison.

#### Responses

**200**: OK

**400**: BadRequest

**402**: PaymentRequired

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/get-costs-for-cost-report-or-vql-filter](https://docs.vantage.sh/api/costs/get-costs-for-cost-report-or-vql-filter)
</Card>

***

### POST /costs/data\_exports

**Generate cost data export**

Generate a DataExport of costs.

#### Request Body

```json theme={null}
{
  "cost_report_token": string // The CostReport token,
  "filter": string // The VQL filter to apply to the costs. If this is supplied you do not need cost_report_token,
  "workspace_token": string // The token of the Workspace to query costs from. Ignored if 'cost_report_token' is set. Required if the API token is associated with multiple Workspaces,
  "start_date": string // First date you would like to filter costs from. ISO 8601 formatted. When omitted with cost_report_token, the report's saved start date is used,
  "end_date": string // Last date you would like to filter costs to. ISO 8601 formatted. When omitted with cost_report_token, the report's saved end date is used,
  "groupings": [string] // Group the results by specific field(s). When omitted with cost_report_token, the report's saved groupings are used; otherwise defaults to provider, service, account_id. Valid groupings: account_id, billing_account_id, charge_type, cost_category, cost_subcategory, provider, region, resource_id, service, tagged, usage_unit, tag:tag_value. If providing multiple groupings, join as comma separated values: groupings=provider,service,region,
  "date_bin": string // The date bin of the costs. Defaults to the report's default or day. Allowed values: `day`, `week`, `month`, `quarter`, `hour`,
  "schema": string // The schema of the data export. Allowed values: `vntg`, `focus`, `comparison`,
  "settings": { // Cost-related settings
    "include_credits": boolean // Results will include credits,
    "include_refunds": boolean // Results will include refunds,
    "include_discounts": boolean // Results will include discounts,
    "include_tax": boolean // Results will include tax,
    "amortize": boolean // Results will amortize,
    "unallocated": boolean // Results will show unallocated costs,
    "aggregate_by": string // Results will aggregate by cost, usage, or count. Allowed values: `cost`, `usage`, `count`,
    "show_previous_period": boolean // Results will show previous period cost, usage, or count comparison
  }
}
```

#### Responses

**202**: The data export has been queued and will be available at the location specified in the Location header.

**400**: BadRequest

**402**: PaymentRequired

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/costs/generate-cost-data-export](https://docs.vantage.sh/api/costs/generate-cost-data-export)
</Card>

***

## DashboardNotifications

### GET /dashboard\_notifications

**Get all dashboard notifications**

Return all DashboardNotifications.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

* **q** (string) - Optional: Search dashboard notifications by title.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboardnotifications/get-all-dashboard-notifications](https://docs.vantage.sh/api/dashboardnotifications/get-all-dashboard-notifications)
</Card>

***

### POST /dashboard\_notifications

**Create dashboard notification**

Create a DashboardNotification.

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the DashboardNotification,
  "dashboard_token": string // required // The Dashboard token,
  "workspace_token": string // The token of the Workspace to add the DashboardNotification to. Required if the API token is associated with multiple Workspaces,
  "user_tokens": [string] // The Users that receive the notification,
  "recipient_emails": [string] // Email addresses that receive the notification. Must be organization users, on the account's SSO domain, or an approved third-party service address,
  "frequency": string // required // The frequency the DashboardNotification is sent. Possible values: daily, weekly, monthly. Allowed values: `daily`, `weekly`, `monthly`
}
```

#### Responses

**201**: Created

**400**: BadRequest

**422**: UnprocessableEntity

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboardnotifications/create-dashboard-notification](https://docs.vantage.sh/api/dashboardnotifications/create-dashboard-notification)
</Card>

***

### DELETE /dashboard\_notifications/{dashboard_notification_token}

**Delete dashboard notification**

Delete a DashboardNotification.

#### Path Parameters

* **dashboard\_notification\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboardnotifications/delete-dashboard-notification](https://docs.vantage.sh/api/dashboardnotifications/delete-dashboard-notification)
</Card>

***

### GET /dashboard\_notifications/{dashboard_notification_token}

**Get dashboard notification by token**

Return a DashboardNotification.

#### Path Parameters

* **dashboard\_notification\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboardnotifications/get-dashboard-notification-by-token](https://docs.vantage.sh/api/dashboardnotifications/get-dashboard-notification-by-token)
</Card>

***

### PUT /dashboard\_notifications/{dashboard_notification_token}

**Update dashboard notification**

Update a DashboardNotification.

#### Path Parameters

* **dashboard\_notification\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the DashboardNotification,
  "dashboard_token": string // The Dashboard token. Retargeting requires edit access to the new Dashboard,
  "user_tokens": [string] // The Users that receive the notification,
  "recipient_emails": [string] // Email addresses that receive the notification. Must be organization users, on the account's SSO domain, or an approved third-party service address,
  "frequency": string // The frequency the DashboardNotification is sent. Possible values: daily, weekly, monthly. Allowed values: `daily`, `weekly`, `monthly`
}
```

#### Responses

**200**: OK

**400**: BadRequest

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboardnotifications/update-dashboard-notification](https://docs.vantage.sh/api/dashboardnotifications/update-dashboard-notification)
</Card>

***

## Dashboards

### GET /dashboards

**Get all dashboards**

Return all Dashboards.

#### Query Parameters

* **page** (integer (int32)) - Optional: The page of results to return.

* **limit** (integer (int32)) - Optional: The amount of results to return. The maximum is 1000.

* **q** (string) - Optional: Search dashboards by title.

* **workspace\_token** (string) - Optional: The workspace token of the dashboards to return.

#### Responses

**200**: OK

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboards/get-all-dashboards](https://docs.vantage.sh/api/dashboards/get-all-dashboards)
</Card>

***

### POST /dashboards

**Create dashboard**

Create a Dashboard.

#### Request Body

```json theme={null}
{
  "title": string // required // The title of the Dashboard,
  "widgets": [ // The widgets to add to the Dashboard. Report-backed widgets use widgetable_token. Free text widgets use widgetable_type set to free_text and require content
    {
      "widgetable_token": string // The token of the represented Resource,
      "widgetable_type": string // The widget type. Use free_text for a free text widget. Allowed values: `free_text`,
      "title": string // The title of the Widget (defaults to the Resource title, or Free Text for a free text widget),
      "content": { // Rich-text document for a free text widget, for example {"type":"doc","content":[{"type":"paragraph","content":[{"type":"text","text":"Note"}]}]}
        "type": string // required // Document root. Must be doc. Allowed values: `doc`,
        "content": [object]
      },
      "settings": { // The display and grid layout settings for the DashboardWidget
        "display_type": string // required // Allowed values: `table`, `chart`, `kpi`,
        "kpi_calculation": string // The aggregation used when display_type is kpi. Allowed values: `sum`, `average`,
        "kpi_type": string // The metric represented when display_type is kpi. Allowed values: `cost`, `usage`, `count`, `business_metric`,
        "kpi_usage_unit": string // The usage unit represented when kpi_type is usage,
        "grid": { // The widget's size and position in the dashboard's 12-column grid
          "x": integer // required // The zero-based horizontal position,
          "y": integer // required // The zero-based vertical position,
          "w": integer // required // The widget width in grid columns,
          "h": integer // required // The widget height in grid rows
        }
      }
    }
  ],
  "saved_filter_tokens": [string] // The tokens of the Saved Filters used in the Dashboard,
  "date_bin": string // Determines how to group costs in the Dashboard. Allowed values: `cumulative`, `day`, `week`, `month`,
  "date_interval": string // Determines the date range in the Dashboard. Incompatible with 'start_date' and 'end_date' parameters. Allowed values: `this_month`, `last_7_days`, `last_30_days`, `last_month`, `last_3_months`, `last_6_months`, `custom`, `last_12_months`, `last_24_months`, `last_36_months`, `next_month`, `next_3_months`, `next_6_months`, `next_12_months`, `year_to_date`, `last_3_days`, `last_14_days`,
  "start_date": string // The start date for the date range for costs in the Dashboard. ISO 8601 Formatted. Incompatible with 'date_interval' parameter,
  "end_date": string // The end date for the date range for costs in the Dashboard. ISO 8601 Formatted. Incompatible with 'date_interval' parameter,
  "workspace_token": string // The token of the Workspace to add the Dashboard to. Required if the API token is associated with multiple Workspaces
}
```

#### Responses

**201**: Created

**400**: BadRequest

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboards/create-dashboard](https://docs.vantage.sh/api/dashboards/create-dashboard)
</Card>

***

### DELETE /dashboards/{dashboard_token}

**Delete dashboard**

Delete a Dashboard.

#### Path Parameters

* **dashboard\_token** (path) (string) - **Required**

#### Responses

**204**: No Content

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboards/delete-dashboard](https://docs.vantage.sh/api/dashboards/delete-dashboard)
</Card>

***

### GET /dashboards/{dashboard_token}

**Get dashboard by token**

Return a specific Dashboard.

#### Path Parameters

* **dashboard\_token** (path) (string) - **Required**

#### Responses

**200**: OK

**404**: NotFound

<Card title="View Full Documentation" icon="external-link">
  For interactive testing, request/response examples, and detailed schemas, visit: [https://docs.vantage.sh/api/dashboards/get-dashboard-by-token](https://docs.vantage.sh/api/dashboards/get-dashboard-by-token)
</Card>

***

### PUT /dashboards/{dashboard_token}

**Update dashboard**

Update a Dashboard.

#### Path Parameters

* **dashboard\_token** (path) (string) - **Required**

#### Request Body

```json theme={null}
{
  "title": string // The title of the Dashboard,
  "widgets": [ // The complete replacement list of widgets for the Dashboard. Omit widgets or send null to preserve every existing widget. When provided, include every report-backed and free text widget to keep; an empty array removes all widgets. Report-backed widgets use widgetable_token. Free text widgets use widgetable_type set to free_text and require content
    {
      "widgetable_token": string // The token of the represented Resource,
      "widgetable_type": string // The widget type. Use free_text for a free text widget. Allowed values: `free_text`,
      "title": string // The title of the Widget (defaults to the Resource title, or Free Text for a free text widget),
      "content": { // Rich-text document for a free text widget, for example {"type":"doc","content":[{"type":"paragraph","content":[{"type":"text","text":"Note"}]}]}
        "type": string // required // Document root. Must be doc. Allowed values: `doc`,
        "content": [object]
      },
      "settings": { // The display and grid layout settings for the DashboardWidget
        "display_type": string // required // Allowed values: `table`, `chart`, `kpi`,
        "kpi_calculation": string // The aggregation used when display_type is kpi. Allowed values: `sum`, `average`,
        "kpi_type": string // The metric represented when display_type is kpi. Allowed values: `cost`, `usage`, `count`, `business_metric`,
        "kpi_usage_unit": string // The usage unit represented when kpi_type is usage,
[...]
